/*
* BearLibTerminal
* Copyright (C) 2013 Cfyz
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
* FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
* COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
* IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
* CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

#ifndef BEARLIBTERMINAL_FREETYPEFONTPROVIDER_HPP
#define BEARLIBTERMINAL_FREETYPEFONTPROVIDER_HPP

#include <ft2build.h>
#include FT_FREETYPE_H

#include "FontProvider.hpp"

namespace BearLibTerminal
{
	class FreetypeFontProvider: public FontProvider
	{
	public:
		//FreetypeFontProvider(dictionary_t& options);
		FreetypeFontProvider(const FontProvider::Options& options);
		~FreetypeFontProvider();
		void Dispose();
		Bitmap GetGlyphBitmap(wchar_t code);
		bool HasGlyph(wchar_t code) const;
		void PopulateTileset(GlyphTileset& tileset, const std::list<wchar_t>& codes);

	protected:
		Bitmap PrepareBitmap(FT_GlyphSlot slot);
		FT_Library m_font_library;
		FT_Face m_font_face;
		FT_Render_Mode m_render_mode;
	};
}

#endif // BEARLIBTERMINAL_FREETYPEFONTPROVIDER_HPP
