/*
* BearLibTerminal
* Copyright (C) 2013 Cfyz
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
* FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
* COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
* IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
* CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

#ifndef BEARLIBTERMINAL_GLYPHTILESET_HPP
#define BEARLIBTERMINAL_GLYPHTILESET_HPP

#include "Tileset.hpp"

namespace BearLibTerminal
{
	class GlyphTileset
	{
	public:
		GlyphTileset();
		size_t GetGlyphCount() const;
		Size GetGlyphSize() const;
		void Clear();
		void Dispose();
		bool HasTileFor(uint16_t code) const;
		void Add(uint16_t code, const Bitmap& bitmap);
		void Add(uint16_t code, const Bitmap& bitmap, const Rectangle& area);
		void Add(uint16_t code, uint16_t alias);
		void Bind();
		void Draw(uint16_t code, Point location) const;
	protected:
		Tileset m_tileset;
		std::vector<uint16_t> m_glyphs;
	};
}

#endif // BEARLIBTERMINAL_GLYPHTILESET_HPP
