/*
* BearLibTerminal
* Copyright (C) 2013 Cfyz
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
* FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
* COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
* IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
* CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

#ifndef BEARLIBTERMINAL_KEYSTROKE_HPP
#define BEARLIBTERMINAL_KEYSTROKE_HPP

#include <cstdint>

namespace BearLibTerminal
{
	struct Keystroke
	{
		inline Keystroke():
			scancode(0),
			character(0),
			pressed(true)
		{ }

		inline Keystroke(uint8_t scancode):
			scancode(scancode),
			character(0),
			pressed(true)
		{ }

		inline Keystroke(uint8_t scancode, bool pressed):
			scancode(scancode),
			character(0),
			pressed(pressed)
		{ }

		inline Keystroke(uint8_t scancode, wchar_t character, bool pressed):
			scancode(scancode),
			character(character),
			pressed(pressed)
		{ }

		uint8_t scancode;
		wchar_t character;
		bool pressed;
		int x, y, z;
	};
}

#endif // BEARLIBTERMINAL_KEYSTROKE_HPP
