/*
* BearLibTerminal
* Copyright (C) 2013 Cfyz
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
* FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
* COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
* IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
* CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

/*
#include <cstdint>
#include "Unicode.hpp"

namespace BearLibTerminal
{
	static const wchar_t kSurrogateHighStart	= 0xD800;
	static const wchar_t kSurrogateHighEnd		= 0xDBFF;
	static const wchar_t kSurrogateLowStart		= 0xDC00;
	static const wchar_t kSurrogateLowEnd		= 0xDFFF;
	static const wchar_t kUnicodeMaxBmp			= 0xFFFF;

	// Number of trailing bytes that are supposed to follow the first byte
	// of a UTF-8 sequence
	static const uint8_t kTrailingBytesForUTF8[256] =
	{
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
		1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
		2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
		3,3,3,3,3,3,3,3,4,4,4,4,5,5,5,5
	};

	// Magic values subtracted from a buffer value during UTF8 conversion.
	// This table contains as many values as there might be trailing bytes
	// in a UTF-8 sequence.
	static const uint32_t kOffsetsFromUTF8[6] =
	{
		0x00000000UL,
		0x00003080UL,
		0x000E2080UL,
		0x03C82080UL,
		0xFA082080UL,
		0x82082080UL
	};

	static const wchar_t kReplacementWideChar = 0x1A; // ASCII 'replacement' character

	std::wstring ConvertUnicode(std::string const& s)
	{
		std::wstring result;

		size_t index = 0;
		while ( index < s.length() )
		{
			size_t extraBytesToRead = kTrailingBytesForUTF8[(uint8_t)s[index]];
			if ( index+extraBytesToRead >= s.length() )
			{
				// Stop here
				return result;
			}

			// TODO: Do UTF-8 check

			uint32_t ch = 0;
			switch ( extraBytesToRead )
			{
				case 5: ch += (uint8_t)s[index++]; ch <<= 6; // illegal UTF-8
				case 4: ch += (uint8_t)s[index++]; ch <<= 6; // illegal UTF-8
				case 3: ch += (uint8_t)s[index++]; ch <<= 6;
				case 2: ch += (uint8_t)s[index++]; ch <<= 6;
				case 1: ch += (uint8_t)s[index++]; ch <<= 6;
				case 0: ch += (uint8_t)s[index++];
			}
			ch -= kOffsetsFromUTF8[extraBytesToRead];

			if ( ch <= kUnicodeMaxBmp )
			{
				// Target is a character <= 0xFFFF
				if ( ch >= kSurrogateHighStart && ch <= kSurrogateHighEnd )
				{
					result.push_back(kReplacementWideChar);
				}
				else
				{
					result.push_back((wchar_t)ch); // Normal case
				}
			}
			else // Above 0xFFFF
			{
				result.push_back(kReplacementWideChar);
			}
		}

		return result;
	}

	std::string ConvertUnicode(const std::wstring& s)
	{
		std::string result;
		for ( wchar_t c: s )
		{
			if ( c < 0x80 )
			{
				result.push_back(c & 0x7F);
			}
			else if ( c < 0x0800 )
			{
				result.push_back(((c >> 6) & 0x1F) | 0xC0);
				result.push_back(((c >> 0) & 0x3F) | 0x80);
			}
			else if ( c < 0x10000 )
			{
				result.push_back(((c >> 12) & 0x0F) | 0xE0);
				result.push_back(((c >>  6) & 0x3F) | 0x80);
				result.push_back(((c >>  0) & 0x3F) | 0x80);
			}
		}

		return result;
	}
}
*/
